Irrlicht Engine: irr::IReferenceCounted Class Reference

Home | Namespaces | Hierarchy | Alphabetical List | Class list | Files | Namespace Members | Class members | File members | Tutorials

# irr::IReferenceCounted Class Reference

Base class of most objects of the Irrlicht Engine. More...

`#include <IReferenceCounted.h>`

Inheritance diagram for irr::IReferenceCounted:

List of all members.

## Public Member Functions
bool | drop () const
| Drops the object. Decrements the reference counter by one.
const c8 * | getDebugName () const
| Returns the debug name of the object.
s32 | getReferenceCount () const
| Get the reference count.
void | grab () const
| Grabs the object. Increments the reference counter by one.
| IReferenceCounted ()
| Constructor.
virtual | ~IReferenceCounted ()
| Destructor.
## Protected Member Functions
void | setDebugName (const c8 *newName)
| Sets the debug name of the object.

## Detailed Description

Base class of most objects of the Irrlicht Engine.

This class provides reference counting through the methods grab() and drop(). It also is able to store a debug string for every instance of an object. Most objects of the Irrlicht Engine are derived from IReferenceCounted, and so they are reference counted.

When you create an object in the Irrlicht engine, calling a method which starts with 'create', an object is created, and you get a pointer to the new object. If you no longer need the object, you have to call drop(). This will destroy the object, if grab() was not called in another part of you program, because this part still needs the object. Note, that you only need to call drop() to the object, if you created it, and the method had a 'create' in it.

A simple example:

If you want to create a texture, you may want to call an imaginable method IDriver::createTexture. You call ITexture* texture = driver->createTexture(dimension2d<u32>(128, 128)); If you no longer need the texture, call texture->drop().

If you want to load a texture, you may want to call imaginable method IDriver::loadTexture. You do this like ITexture* texture = driver->loadTexture("example.jpg"); You will not have to drop the pointer to the loaded texture, because the name of the method does not start with 'create'. The texture is stored somewhere by the driver.

Definition at line 41 of file IReferenceCounted.h.

## Constructor & Destructor Documentation

irr::IReferenceCounted::IReferenceCounted | ( |  | ) | `[inline]`

Constructor.

Definition at line 46 of file IReferenceCounted.h.

virtual irr::IReferenceCounted::~IReferenceCounted | ( |  | ) | `[inline, virtual]`

Destructor.

Definition at line 52 of file IReferenceCounted.h.

## Member Function Documentation

bool irr::IReferenceCounted::drop | ( |  | ) | const`[inline]`

Drops the object. Decrements the reference counter by one.

The IReferenceCounted class provides a basic reference counting mechanism with its methods grab() and drop(). Most objects of the Irrlicht Engine are derived from IReferenceCounted, and so they are reference counted.

When you create an object in the Irrlicht engine, calling a method which starts with 'create', an object is created, and you get a pointer to the new object. If you no longer need the object, you have to call drop(). This will destroy the object, if grab() was not called in another part of you program, because this part still needs the object. Note, that you only need to call drop() to the object, if you created it, and the method had a 'create' in it.

A simple example:

If you want to create a texture, you may want to call an imaginable method IDriver::createTexture. You call ITexture* texture = driver->createTexture(dimension2d<u32>(128, 128)); If you no longer need the texture, call texture->drop(). If you want to load a texture, you may want to call imaginable method IDriver::loadTexture. You do this like ITexture* texture = driver->loadTexture("example.jpg"); You will not have to drop the pointer to the loaded texture, because the name of the method does not start with 'create'. The texture is stored somewhere by the driver.

Returns:
  True, if the object was deleted.

Definition at line 116 of file IReferenceCounted.h.

References _IRR_DEBUG_BREAK_IF.

Referenced by irr::scene::ISceneNode::cloneMembers(), irr::scene::quake3::getTextures(), irr::scene::CDynamicMeshBuffer::getVertexBuffer(), irr::scene::ISceneNode::setParent(), irr::scene::ISceneNode::setTriangleSelector(), irr::scene::ISceneNode::~ISceneNode(), irr::scene::SAnimatedMesh::~SAnimatedMesh(), and irr::scene::SMesh::~SMesh().

const c8* irr::IReferenceCounted::getDebugName | ( |  | ) | const`[inline]`

Returns the debug name of the object.

The Debugname may only be set and changed by the object itself. This method should only be used in Debug mode.

Returns:
  Returns a string, previously set by setDebugName();

Definition at line 142 of file IReferenceCounted.h.

s32 irr::IReferenceCounted::getReferenceCount | ( |  | ) | const`[inline]`

Get the reference count.

Returns:
  Current value of the reference counter.

Definition at line 133 of file IReferenceCounted.h.

void irr::IReferenceCounted::grab | ( |  | ) | const`[inline]`

Grabs the object. Increments the reference counter by one.

Someone who calls grab() to an object, should later also call drop() to it. If an object never gets as much drop() as grab() calls, it will never be destroyed. The IReferenceCounted class provides a basic reference counting mechanism with its methods grab() and drop(). Most objects of the Irrlicht Engine are derived from IReferenceCounted, and so they are reference counted.

When you create an object in the Irrlicht engine, calling a method which starts with 'create', an object is created, and you get a pointer to the new object. If you no longer need the object, you have to call drop(). This will destroy the object, if grab() was not called in another part of you program, because this part still needs the object. Note, that you only need to call drop() to the object, if you created it, and the method had a 'create' in it.

A simple example:

If you want to create a texture, you may want to call an imaginable method IDriver::createTexture. You call ITexture* texture = driver->createTexture(dimension2d<u32>(128, 128)); If you no longer need the texture, call texture->drop(). If you want to load a texture, you may want to call imaginable method IDriver::loadTexture. You do this like ITexture* texture = driver->loadTexture("example.jpg"); You will not have to drop the pointer to the loaded texture, because the name of the method does not start with 'create'. The texture is stored somewhere by the driver.

Definition at line 86 of file IReferenceCounted.h.

Referenced by irr::scene::ISceneNode::addAnimator(), irr::scene::ISceneNode::addChild(), irr::gui::IGUIElement::addChildToEnd(), irr::scene::SAnimatedMesh::addMesh(), irr::scene::SMesh::addMeshBuffer(), irr::scene::ISceneNode::setParent(), and irr::scene::ISceneNode::setTriangleSelector().

void irr::IReferenceCounted::setDebugName | ( | const c8 * | newName | ) | `[inline, protected]`

Sets the debug name of the object.

The Debugname may only be set and changed by the object itself. This method should only be used in Debug mode.

Parameters:

  | newName,: | New debug name to set.

Definition at line 153 of file IReferenceCounted.h.

Referenced by irr::scene::CMeshBuffer< T >::CMeshBuffer(), irr::gui::IGUIElement::IGUIElement(), irr::scene::SAnimatedMesh::SAnimatedMesh(), irr::scene::SMesh::SMesh(), irr::scene::SSharedMeshBuffer::SSharedMeshBuffer(), and irr::scene::SSkinMeshBuffer::SSkinMeshBuffer().

The documentation for this class was generated from the following file:

- IReferenceCounted.h

| The Irrlicht Engine Documentation © 2003-2010 by Nikolaus Gebhardt. Generated on Sun Oct 24 12:42:03 2010 by Doxygen (1.6.2)